const gs = (g) => (contexts, separator, last_separator) => {
  s = ''
  if (!separator) {
    separator = ' '
  }
  if (!last_separator) {
    last_separator = separator
  }
  next_separator = ''
  for (let i = 0; i < contexts.length; ++i) {
    const context = contexts[i]
    value = g(context)
    if (i > 0) {
      if (i == contexts.length - 1) {
        next_separator = last_separator
      } else {
        next_separator = separator
      }
    }
    s += next_separator + value
  }
  return s
}

class Generator {
  constructor (matcher, action, uuid) {
    this.matcher = matcher
    this.action = action
    this.uuid = uuid
  }

  getAPI (config) {
    if (config && config.getAPI) {
      return config.getAPI(this.uuid)
    }
  }

  toString () {
    return `Generator(${this.matcher}, ${this.action})`
  }

  matches (objects, context, config) {
    if (objects && objects.namespaced) {
      objects = objects.namespaced[this.uuid]
    }
    return this.matcher({ objects, global: objects, context, api: this.getAPI(config) })
  }

  apply (objects, g, context, config, response) {
    this.getAPI(config)
    let n = (id) => id
    if (config && 'nsToString' in config) {
      n = (id) => config.nsToString(id)
    }
    if (objects && objects.namespaced) {
      objects = objects.namespaced[this.uuid]
    }
    return this.action({ objects, global: objects, g, n, context, uuid: this.uuid, gs: gs(g), config, response, api: this.getAPI(config) })
  }
}

class Generators {
  constructor (generators) {
    this.generators = generators
    this.logs = []
  };

  // assumed - properties added to contexts before the generators are called. For setting paraphrase property
  apply (objects, contexts, config, response, assumed = {}) {
    if (Array.isArray(contexts)) {
    } else if (typeof contexts === 'object') {
      contexts = [contexts]
    } else {
      return String(contexts)
    }

    const contexts_prime = []
    for (const icontext in contexts) {
      let context = contexts[icontext]
      context = Object.assign({}, context, assumed)
      // let context_prime = JSON.stringify(context);
      let context_prime = context
      for (let igenerator = 0; igenerator < this.generators.length; ++igenerator) {
        const generator = this.generators[igenerator]
        if (generator.matches(objects, context, config)) {
          const g = (context) => this.apply(objects, context, config, response, assumed)
          this.logs.push(`Generators: applied ${generator.toString()}\n to\n ${JSON.stringify(context)}`)
          context_prime = generator.apply(objects, g, context, config, response)
          this.logs.push(`Generators: applied ${generator.toString()}\n to\n ${JSON.stringify(context)}\nthe result was "${context_prime}"`)
          break
        }
      }
      contexts_prime.push(context_prime)
    }
    return contexts_prime
  }
}

module.exports = { Generator, Generators }
